#ifndef CHAR_READER_H
#define CHAR_READER_H

#include "vec.h"
#include <stddef.h>
#include <stdio.h>

typedef struct CharReader CharReader;
struct CharReader {
    char (*next)(CharReader* reader);
    StringSlice (*value)(const CharReader* reader, size_t index, size_t length);
};

typedef struct FileCharReader FileCharReader;
struct FileCharReader {
    char (*next)(FileCharReader* reader);
    StringSlice (*value)(
        const FileCharReader* reader, size_t index, size_t length
    );
    FILE* file;
    String buffer;
};

void file_char_reader_construct(FileCharReader* reader, FILE* file);
void file_char_reader_destroy(FileCharReader* reader);
char file_char_reader_next(FileCharReader* reader);
StringSlice file_char_reader_value(
    const FileCharReader* reader, size_t index, size_t length
);

#endif
