#ifndef PANIC_H
#define PANIC_H

#include <stdio.h>
#include <stdlib.h>

#define PANIC(...)                                                             \
    (fprintf(stderr, "panic: "),                                               \
     fprintf(stderr, __VA_ARGS__),                                             \
     fprintf(stderr, ", at %s:%d in %s()\n", __FILE__, __LINE__, __func__),    \
     exit(1));

#define ASSERT(CONDITION)                                                      \
    {                                                                          \
        if (!(CONDITION)) {                                                    \
            (fprintf(stderr, "assertion failed: "),                            \
             fprintf(                                                          \
                 stderr,                                                       \
                 "(%s), at %s:%d in %s()\n",                                   \
                 #CONDITION,                                                   \
                 __FILE__,                                                     \
                 __LINE__,                                                     \
                 __func__                                                      \
             ),                                                                \
             exit(1));                                                         \
        }                                                                      \
    };

#endif
