#ifndef VEC_H
#define VEC_H

#include <stdbool.h>
#include <stddef.h>

typedef struct {
    const char* data;
    size_t length;
} StringSlice;

bool string_slice_equal(StringSlice slice, const char* data);

typedef struct {
    char* data;
    size_t length;
    size_t capacity;
} String;

void string_construct(String* string);
void string_destroy(String* string);
void string_from_cstr(String* string, const char* value);
void string_from_slice(String* string, StringSlice slice);
void string_append(String* string, const String* value);
void string_append_char(String* string, char value);
void string_append_cstr(String* string, const char* value);
void string_append_format(String* string, const char* format, ...);
bool string_equal(const String* string, const char* value);

#endif
